package pila;

public class PilaCollegata implements Pila {
	private Record top = null;
	
	private class Record {
		Object elem;
		Record next;
		Record(Object elem) {
			this.elem = elem;
		}
	}
	
	public boolean isEmpty() {
		return top == null;
	}

	public void pop() {
		if (isEmpty())
			throw new EccezioneStrutturaVuota("Pila vuota");
		Record temp = top;
		top = top.next;
		temp.next = null;
	}

	public void push(Object e) {
		Record nuovo = new Record(e);
		nuovo.next = top;
		top = nuovo;
	}

	public Object top() {
		if (isEmpty())
			throw new EccezioneStrutturaVuota("Pila vuota");
		return top.elem;
	}

}
